package net.wanji.opt.controllerv2.report.design;

import com.alibaba.fastjson.JSON;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import net.wanji.opt.controllerv2.judgeanalysis.design.response.ParentResult;

import java.util.ArrayList;
import java.util.List;

@Data
public class GreenReportProblemOverallAnalysis extends ParentResult {

    private GreenReportProblemOverallAnalysisResponse content;

    public GreenReportProblemOverallAnalysisResponse getContent() {
        return content;
    }

    public GreenReportProblemOverallAnalysis setContent(GreenReportProblemOverallAnalysisResponse content) {
        this.content = content;
        return this;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}


@Data
class GreenReportProblemOverallAnalysisResponse {

    @ApiModelProperty(value = "区域干线总拥堵次数", example = "56次")
    private String totalCongestCount;

    @ApiModelProperty(value = "区域干线总拥堵时长", example = "11小时")
    private String totalCongestDuration;

    @ApiModelProperty(value = "拥堵严重干线",example = "经十路（舜耕路-山大路）、经十路（洪山路-舜华路）")
    private   String congestHeavyGreenWave;

    private List<GreenReportProblemOverallData> dataList = new ArrayList<>();

}


@Data
class GreenReportProblemOverallData {

    @ApiModelProperty(value = "排序", example = "")
    private String sort;
    @ApiModelProperty(value = "干线ID", example = "")
    private String greenId;
    @ApiModelProperty(value = "干线名称", example = "经十路（舜耕路-山大路）")
    private String greenName;
    List<GreenWaveDirProblemData> list = new ArrayList<>();

}

@Data
class  GreenWaveDirProblemData{
    @ApiModelProperty(value = "干线类型", example = "主干路")
    private String greenWaveType;

    @ApiModelProperty(value = "方向", example = "东向西")
    private String dir;

    @ApiModelProperty(value = "拥堵指数", example = "4.5")
    private Double congestIndex;

    @ApiModelProperty(value = "拥堵次数", example = "10")
    private Integer congestCount;

    @ApiModelProperty(value = "拥堵时长，单位秒", example = "10")
    private Integer congestDuration;

}


