package net.wanji.opt.controllerv2.report.design;

import com.alibaba.fastjson.JSON;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import net.wanji.opt.controllerv2.judgeanalysis.design.response.ParentResult;

import java.util.ArrayList;
import java.util.List;

@Data
public class GreenWaveOptimizeAnalysisResult extends ParentResult {

    private GreenWaveOptimizeAnalysisResultResponse content;

    public  GreenWaveOptimizeAnalysisResultResponse getContent() {
        return content;
    }

    public GreenWaveOptimizeAnalysisResult setContent(GreenWaveOptimizeAnalysisResultResponse content) {
        this.content = content;
        return this;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}

@Data
class  GreenWaveOptimizeAnalysisResultResponse {

    @ApiModelProperty(value = "干线ID", example = "")
    private String greenId;

    @ApiModelProperty(value = "干线名称", example = "经十路（舜耕路-山大路）")
    private String greenName;

    @ApiModelProperty(value = "本周优化次数", example = "300次")
    private String weekOptimizeCount;

    @ApiModelProperty(value = "本周优化时长", example = "98小时")
    private String weekOptimizeDuration;

    @ApiModelProperty(value = "本周通行能力同比情况", example = "提升10%")
    private String weekCapacitySituation;

    @ApiModelProperty(value = "本周通停车次数同比情况", example = "减少10%")
    private String weekStopTimesSituation;

    @ApiModelProperty(value = "本周通行程时间数同比情况", example = "增加10%")
    private String weekTravelTimeSituation;

    @ApiModelProperty(value = "本周通延误时间同比情况", example = "增加10%")
    private String weekDelayTimeSituation;

    @ApiModelProperty(value = "本周通平均速度同比情况", example = "降低10%")
    private String weekAvgSpeedSituation;

    @ApiModelProperty(value = "本周总体情况", example = "降低10%")
    private String weekTotalitySituation;

    //================================================================================================//

    @ApiModelProperty(value = "时段列表",example = "[\"本周\",\"上周\"]")
    private   List<String> timeList = new ArrayList<>();

    private List<GreenWaveOptimizeAnalysisData> dataList=new ArrayList<>();

}

@Data
class GreenWaveOptimizeAnalysisData  {

    @ApiModelProperty(value = "通行能力",example = "8900")
    private   Integer capacity ;

    @ApiModelProperty(value = "停车次数",example = "5")
    private   Double stopTimes ;

    @ApiModelProperty(value = "延误时间，单位秒",example = "40")
    private   Double delayTime ;

    @ApiModelProperty(value = "行程时间，单位秒",example = "6.9")
    private   Double travelTime ;

    @ApiModelProperty(value = "平均速度",example = "39")
    private   Double avgSpeed ;

}



