package net.wanji.opt.dao.mapper.judgeanalysis;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import net.wanji.opt.entity.judgeanalysis.AnalysisProblemCrossDay;
import net.wanji.opt.entity.judgeanalysis.CrossPoint;
import net.wanji.opt.synthesis.pojo.CrossOptAnalysisEntity;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface AnalysisProblemCrossDayMapper extends BaseMapper<AnalysisProblemCrossDay>{
	
	 /**
	  *  查询表t_analysis_problem_cross_day所有信息
	  */
	 List<AnalysisProblemCrossDay> findAllAnalysisProblemCrossDay();
	  
	 /**
	  *  根据主键id查询表t_analysis_problem_cross_day信息
	  *  @param id
	  */
	 AnalysisProblemCrossDay findAnalysisProblemCrossDayByid(@Param("id") String id);

	/**
	*  根据条件查询表t_analysis_problem_cross_day信息
	*  @param analysisProblemCrossDay
	*/
	List<AnalysisProblemCrossDay> findAnalysisProblemCrossDayByCondition(AnalysisProblemCrossDay analysisProblemCrossDay);

	 /**
	  *  根据主键id查询表t_analysis_problem_cross_day信息
	  *  @param id
	  */
	 Integer deleteAnalysisProblemCrossDayByid(@Param("id") String id);
	
	 /**
	  *  根据主键id更新表t_analysis_problem_cross_day信息
	  *  @param analysisProblemCrossDay
	  */
	 Integer updateAnalysisProblemCrossDayByid(AnalysisProblemCrossDay analysisProblemCrossDay);
	
	 /**
	  *  新增表t_analysis_problem_cross_day信息
	  *  @param analysisProblemCrossDay
	  */
	 Integer addAnalysisProblemCrossDay(AnalysisProblemCrossDay analysisProblemCrossDay);

	/**
	 *  根据主键id更新表t_base_cross_info信息
	 *  @param areaId,id
	 */
	Integer updateCrossAreaIdByid(@Param("areaId") String areaId ,@Param("id") String id);

	/**
	 *  根据主键id更新表t_base_cross_info信息
	 *  @param areaId,id
	 */
	Integer updateGreenAreaIdByid(@Param("areaId") String areaId ,@Param("id") String id);

	/**
	 *  查询表t_base_cross_info信息
	 *  @param
	 */
	List<CrossPoint> findCrossPoint();

	/**
	 *  查询表t_base_cross_info信息
	 *  @param
	 */
	List<CrossPoint> findGreenPoint();

	/**
	 *  查询表t_base_area_info信息
	 *  @param
	 */
	List<CrossPoint> findAreaPoint();

	/**
	 *  查询表t_base_area_info信息
	 *  @param
	 */
	List<AnalysisProblemCrossDay> checkData();

	/**
	 *  新增表t_analysis_problem_cross_day信息
	 *  @param
	 */
	Integer insertAnalysisProblemCrossDay();

	/**
	 *  新增表t_analysis_problem_cross_dir_hour信息
	 *  @param
	 */
	Integer insertAnalysisProblemCrossHour();


	/***
	 * 根据类型统计对应数量
	 * @param map
	 * @return
	 */
	List<AnalysisProblemCrossDay> selectCountByType(Map<String, Object> map);


	List<AnalysisProblemCrossDay> getListSingleByStartAndEnd(Map<String, Object> map);

	List<AnalysisProblemCrossDay> selectSingerByProblemTrend(Map<String, Object> map);

	/**
	 * 获取路口优化数据
	 */
	List<CrossOptAnalysisEntity> getCrossOptAnalysis(@Param("greenId") String greenId,@Param("crossID") String crossID,   @Param("startTime")String startTime,@Param("endTime")String endTime);
}

