package net.wanji.opt.dao.mapper.strategy;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import net.wanji.opt.entity.strategy.StrategyParameterConfig;
import net.wanji.opt.entity.strategy.StrategyPriorityConfig;
import net.wanji.opt.entity.strategy.StrategyPriorityDailyInfo;
import java.util.List;
import java.util.Map;

import net.wanji.opt.entity.strategy.dto.StrategyPriorityGroup;
import net.wanji.opt.synthesis.pojo.StrategyFactoryEntity;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

public interface StrategyPriorityMapper extends BaseMapper<StrategyPriorityDailyInfo>{
	
	 /**
	  *  查询表t_strategy_priority_daily_info所有信息
	  */
	 List<StrategyPriorityDailyInfo> findAllStrategyPriorityDailyInfo();
	  
	 /**
	  *  根据主键id查询表t_strategy_priority_daily_info信息
	  *  @param id
	  */
	 StrategyPriorityDailyInfo findStrategyPriorityDailyInfoByid(@Param("id") Long id);

	/**
	*  根据条件查询表t_strategy_priority_daily_info信息
	*  @param strategyPriorityDailyInfo
	*/
	List<StrategyPriorityDailyInfo> findStrategyPriorityDailyInfoByCondition(StrategyPriorityDailyInfo strategyPriorityDailyInfo);

	 /**
	  *  根据主键id查询表t_strategy_priority_daily_info信息
	  *  @param id
	  */
	 Integer deleteStrategyPriorityDailyInfoByid(@Param("id") Long id);
	
	 /**
	  *  根据主键id更新表t_strategy_priority_daily_info信息
	  *  @param strategyPriorityDailyInfo
	  */
	 Integer updateStrategyPriorityDailyInfoByid(StrategyPriorityDailyInfo strategyPriorityDailyInfo);
	
	 /**
	  *  新增表t_strategy_priority_daily_info信息
	  *  @param strategyPriorityDailyInfo
	  */
	 Integer addStrategyPriorityDailyInfo(StrategyPriorityDailyInfo strategyPriorityDailyInfo);


	List<StrategyPriorityDailyInfo> pageStrategyCrossList();


	List<StrategyFactoryEntity> getStrategyList();

	List<StrategyFactoryEntity> getSceneList();

	List<StrategyFactoryEntity> getCompanyList();


	void savePriorityInsert(List<StrategyPriorityConfig> saveList);


	List<StrategyPriorityConfig> selectPriorityTable(String crossId);

	void deletePriorityConfig(String crossId);



	List<String> getstrategyNo(String crossId);

	List<StrategyFactoryEntity> getPriorityConfigData(@Param("strategyNo") List<String> strategyNo,@Param("crossId") String crossId);

	void savePlanConfig(@Param("savePlanList") List<StrategyPriorityDailyInfo> savePlanList);

	List<StrategyPriorityDailyInfo> selectPlanTable(String crossId);

	void deletePlanConfig(String crossId);


	List<StrategyPriorityDailyInfo> getPlanConfigData(String crossId);

	List<StrategyParameterConfig> paramterConfigTable(String crossId);


	void deleteParamterConfig(String crossId);

	void saveParamConfig(@Param("savePlanList") List<StrategyParameterConfig> savePlanList);

	List<StrategyParameterConfig> getParamConfigData(String crossId);
}

