package net.wanji.opt.entity.report;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.baomidou.mybatisplus.annotation.TableName;

@Data
@EqualsAndHashCode(callSuper=false)
@TableName("t_analysis_green_wave_optimize_week")
public class AnalysisGreenWaveOptimizeWeek implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "green_id", type = IdType.AUTO)
    private Integer greenId;

    /**
     * 干线车流运行方向 w2e/e2w/s2n/n2s
     */
    private String roadDirection;

    /**
     * 星期几：1~7代表周一至周日
     */
    private Integer weekDay;
    /**
     * 拥堵指数
     */
    private Double congestIndex;

    /**
     * 优化时段开始时间
     */
    private LocalDateTime optimizeStartTime;

    /**
     * 优化时段截止时间
     */
    private LocalDateTime optimizeEndTime;

    /**
     * 策略ID
     */
    private Integer stragetyId;

    /**
     * 策略时段内优化次数
     */
    private Integer optimizeCount;

    /**
     * 策略时段内优化总时长，单位秒
     */
    private Integer optimizeDuration;

    /**
     * 通行能力（辆）
     */
    private Integer capacity;

    /**
     * 停车次数
     */
    private Double stopTimes;

    /**
     * 延误时间，单位秒
     */
    private Double delayTime;

    /**
     * 行程时间，单位秒
     */
    private Integer travelTime;

    /**
     * 平均速度，单位km/h
     */
    private Double speed;

    /**
     * 一年中的第几周
     */
    private Integer yearWeek;

    /**
     * 一一年中的第几周，格式yyyyw，如20251
     */
    private LocalDateTime weekStartTime;

    /**
     * 一周的第二天
     */
    private LocalDateTime weekEndTime;

    /**
     * 数据插入时间
     */
    private LocalDateTime insertTime;


}
