package net.wanji.opt.servicev2.comprehensivequery.impl;


import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import net.wanji.common.enums.BaseEnum;
import net.wanji.opt.dao.mapper.comprehensivequery.ComprehensiveQueryMapper;
import net.wanji.opt.entity.comprehensivequery.CrossEntity;
import net.wanji.opt.entity.comprehensivequery.CrossLaneDataHistPoExtendName;
import net.wanji.opt.entity.comprehensivequery.GreenAndCrossEntity;
import net.wanji.opt.entity.comprehensivequery.GreenTreeEntity;
import net.wanji.opt.po.base.CrossLaneDataHistPoExtend;
import net.wanji.opt.po.strategy.StrategyPO;
import net.wanji.opt.servicev2.comprehensivequery.ComprehensiveQueryService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.validation.constraints.Future;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 * 综合查询
 * </p>
 *
 * @author huangwm
 * @since 2025-03-26
 */
@Service
public class ComprehensiveQueryServiceImpl implements ComprehensiveQueryService {
    @Resource
    private ComprehensiveQueryMapper comprehensiveQueryMapper;

    @Override
    public List<GreenTreeEntity> getGreenAndCross() {
        List<GreenAndCrossEntity> list =  comprehensiveQueryMapper.getGreenAndCross();
        String greenNameTemp = "";
        List<CrossEntity> crossList = new ArrayList<>();
        List<GreenTreeEntity> greenList = new ArrayList<>();
        GreenTreeEntity greenTreeEntity = new GreenTreeEntity();
        CrossEntity crossEntity = new CrossEntity();
        int a = 0;
        for(GreenAndCrossEntity temp : list){
            // 判断干线名称是否一致
            if(!greenNameTemp.equals(temp.getGreenName())){
                greenNameTemp = temp.getGreenName();
                //判断是否是空数组，第一次进入的时候是空数组，后续是有数据的数组需要把数据添加进去
                if(greenTreeEntity.getGreenId() != null){
                    greenTreeEntity.setChildren(crossList);
                    greenList.add(greenTreeEntity);
                    greenTreeEntity = new GreenTreeEntity();
                    greenTreeEntity.setGreenId(temp.getGreenId());
                    greenTreeEntity.setGreenName(temp.getGreenName());
                    crossEntity = new CrossEntity();
                    crossList = new ArrayList<>();
                    crossEntity.setCrossName(temp.getCrossName());
                    crossEntity.setCrossId(temp.getCrossId());
                    crossList.add(crossEntity);
                }else {
                    greenTreeEntity.setGreenId(temp.getGreenId());
                    greenTreeEntity.setGreenName(temp.getGreenName());
                    crossEntity = new CrossEntity();
                    crossList = new ArrayList<>();
                    crossEntity.setCrossName(temp.getCrossName());
                    crossEntity.setCrossId(temp.getCrossId());
                    crossList.add(crossEntity);
                }

            }else {
                crossEntity = new CrossEntity();
                crossEntity.setCrossName(temp.getCrossName());
                crossEntity.setCrossId(temp.getCrossId());
                crossList.add(crossEntity);
                if (a == list.size() - 1) {
                    greenTreeEntity.setChildren(crossList);
                    greenList.add(greenTreeEntity);
                }
            }
            a++;
        }
        return greenList;
    }

    @Override
    public JSONObject getCrossStatusDistribution(String crossId , String startTime ,String endTime ,String objectType ,String groupType,Integer pageNum,Integer pageSize) {
        List<CrossLaneDataHistPoExtendName> resultList = new ArrayList<>();
        List<GreenAndCrossEntity> CrossList = comprehensiveQueryMapper.getCross();
        String[] crossIdArray = crossId.split(",");
        for (String id : crossIdArray) {
            String crossName = "";
            for(GreenAndCrossEntity temp : CrossList){
                if(id.equals(temp.getCrossId())){
                    crossName = temp.getCrossName();
                }
            }
            Map<String, Object> params = new HashMap<>();
            params.put("crossId", id);
            params.put("startDate", startTime);
            params.put("endDate", endTime);
            params.put("groupType", groupType);
            params.put("objectType", objectType);
            List<CrossLaneDataHistPoExtend> list = comprehensiveQueryMapper.findCrossObjectIndex(params);
            for (CrossLaneDataHistPoExtend c : list) {
                CrossLaneDataHistPoExtendName temp = new CrossLaneDataHistPoExtendName();
                temp.setCrossId(c.getCrossId());
                temp.setStartTime(c.getStartTime());
                temp.setDirType(c.getDirType());
                temp.setTurnType(c.getTurnType());
                temp.setFlow(c.getFlow());
                temp.setSpeed(c.getSpeed());
                temp.setMaxQueueLength(c.getMaxQueueLength());
                temp.setMinQueueLength(c.getMinQueueLength());
                temp.setAvgQueueLength(c.getAvgQueueLength());
                temp.setStopTimes(c.getStopTimes());
                temp.setDelayTime(c.getDelayTime());
                temp.setTrafficIndex(c.getTrafficIndex());
                temp.setCrossName(crossName);
                temp.setEndTime(c.getEndTime());
                if(c.getDirType() != null && c.getDirType() > 0 ){
                    temp.setDirTypeName(BaseEnum.SignalDirectionEnum.getNameByCode(c.getDirType()));
                }
                if(c.getTurnType() != null && c.getTurnType() > 0){
                    temp.setTurnTypeName(BaseEnum.TurnTypeEnum.getNameByCode(c.getTurnType()));
                }


                resultList.add(temp);
            }
        }
        List<CrossLaneDataHistPoExtendName> collect = new ArrayList<>();
        if(CollectionUtils.isNotEmpty(resultList)){
             collect = resultList.stream().skip((pageNum - 1) * pageSize).limit(pageSize).collect(Collectors.toList());
        }
        JSONObject result = new JSONObject();
        result.put("fullDataList",resultList);
        result.put("pageList",collect);
        result.put("totalPage",Math.ceil((double) resultList.size() / pageSize));
        result.put("totalSize",resultList.size());
        return result;
    }

}
