package net.wanji.opt.servicev2.evaluation.impl;


import lombok.extern.slf4j.Slf4j;
import net.wanji.common.framework.dubbointerface.impl.BaseDubboInterfaceImpl;
import net.wanji.common.framework.mapper.BaseInterfaceMapper;
import net.wanji.opt.dao.mapper.evaluation.EventInfoMapper;
import net.wanji.opt.entity.evaluation.EventInfo;
import net.wanji.opt.servicev2.evaluation.EventInfoService;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;


/**
 * <p>
 * 交通事件信息
 * </p>
 *
 * @Author wangtao
 * @Date 2025-03-18
 */
@Slf4j
@Component
@Service
public class EventInfoServiceImpl extends BaseDubboInterfaceImpl<EventInfo> implements EventInfoService {

    @Resource
    private EventInfoMapper eventInfoMapper;


    @Override
    public BaseInterfaceMapper<EventInfo> getBaseInterfaceMapper() {
        return this.eventInfoMapper;
    }

    public List<Map<String,Object>> getListByStartAndEnd(Map<String, Object> map){
        return this.eventInfoMapper.getListByStartAndEnd(map);
    }

}
