package net.wanji.opt.servicev2.report.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import net.wanji.databus.dao.entity.GreenwaveInfoPO;
import net.wanji.databus.dao.mapper.GreenwaveInfoMapper;
import net.wanji.opt.entity.report.AnalysisGreenWaveOptimizeWeek;
import net.wanji.opt.dao.mapper.report.AnalysisGreenWaveOptimizeWeekMapper;
import net.wanji.opt.servicev2.report.AnalysisGreenWaveOptimizeWeekService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
* <p>
*  服务实现类
* </p>
*
* @author fengyi
* @since 2025-04-09
*/
@Service
 public class AnalysisGreenWaveOptimizeWeekServiceImpl extends ServiceImpl<AnalysisGreenWaveOptimizeWeekMapper, AnalysisGreenWaveOptimizeWeek> implements AnalysisGreenWaveOptimizeWeekService {

	 @Resource
	 private AnalysisGreenWaveOptimizeWeekMapper analysisGreenWaveOptimizeWeekMapper;
	@Autowired
	private GreenwaveInfoMapper greenwaveInfoMapper;
	
	 /**
	 * 详情
	 * @param id
	 * @return
	 */
	 @Override
	 public AnalysisGreenWaveOptimizeWeek info(Long id) {
	
	 	return getById(id);
	 }
	
	 /**
	 * 新增
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void add(AnalysisGreenWaveOptimizeWeek param) {
	
	 	save(param);
	 }
	
	 /**
	 * 修改
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void modify(AnalysisGreenWaveOptimizeWeek param) {
	
	 	updateById(param);
	 }
	
	 /**
	 * 删除(单个条目)
	 * @param id
	 * @return
	 */
	 @Override
	 public void remove(Long id) {
	 	removeById(id);
	 }
	
	 /**
	 * 删除(多个条目)
	 * @param ids
	 * @return
	 */
	 @Override
	 public void removes(List<Long> ids) {
	
	 	removeByIds(ids);
	 }

	@Override
	public void getTotalityData(Integer year, Integer week, String ids) {
		Integer yearWeek = Integer.valueOf(year + "" + week);
		List<Integer> greenIdList = new ArrayList<>();
		if(ObjectUtils.isEmpty(ids)){
			List<GreenwaveInfoPO> greenwaveInfoPOList = greenwaveInfoMapper.selectAll();
			greenIdList = greenwaveInfoPOList.stream().map(GreenwaveInfoPO::getId).collect(Collectors.toList());
		}else {
			greenIdList = Arrays.stream(ids.split(","))
					.map(String::trim) // 去除可能的空格
					.filter(s -> !s.isEmpty()) // 过滤掉空字符串
					.map(Integer::parseInt) // 转换为整数
					.collect(Collectors.toList());
		}
		LambdaQueryWrapper<AnalysisGreenWaveOptimizeWeek> queryWrapper = new LambdaQueryWrapper<>();
		queryWrapper.eq(AnalysisGreenWaveOptimizeWeek::getYearWeek,yearWeek);
		queryWrapper.in(AnalysisGreenWaveOptimizeWeek::getGreenId,greenIdList);
		List<AnalysisGreenWaveOptimizeWeek> analysisGreenWaveOptimizeWeeks = analysisGreenWaveOptimizeWeekMapper.selectList(queryWrapper);

	}
}
