package net.wanji.opt.servicev2.strategy;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import net.wanji.common.framework.rest.JsonViewObject;
import net.wanji.opt.entity.strategy.StrategyParameterConfig;
import net.wanji.opt.entity.strategy.StrategyPriorityDailyInfo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import net.wanji.opt.entity.strategy.dto.StrategyPriorityGroup;
import net.wanji.opt.synthesis.pojo.StrategyFactoryEntity;

import java.util.List;
import java.util.Map;

/**
* <p>
* 策略优先级日计划详情表 服务类
* </p>
*
* @author fengyi
* @since 2025-03-28
*/
public interface StrategyPriorityService extends IService<StrategyPriorityDailyInfo> {

    /**
    * 策略优先级日计划详情表详情
    * @param id
    * @return
    */
    StrategyPriorityDailyInfo info(Long id);

    /**
    * 策略优先级日计划详情表新增
    * @param param 根据需要进行传值
    * @return
    */
    void add(StrategyPriorityDailyInfo param);

    /**
    * 策略优先级日计划详情表修改
    * @param param 根据需要进行传值
    * @return
    */
    void modify(StrategyPriorityDailyInfo param);

    /**
    * 策略优先级日计划详情表删除(单个条目)
    * @param id
    * @return
    */
    void remove(Long id);

    /**
    * 删除(多个条目)
    * @param ids
    * @return
    */
    void removes(List<Long> ids);

    List<StrategyPriorityDailyInfo>pageStrategyCrossList();

    List<StrategyFactoryEntity> getStrategyList();

    List<StrategyFactoryEntity> getSceneList();

    List<StrategyFactoryEntity> getCompanyList();


    void savePriority(List<StrategyPriorityGroup> dataList);

    List<StrategyFactoryEntity> getPriorityData(String crossId);

    void savePlanConfig(List<StrategyPriorityGroup> dailyPlanDetails) throws JsonProcessingException;


    List<StrategyPriorityDailyInfo> getPlanConfigData(String crossId);

    void saveParamterConfig(StrategyPriorityGroup strategyPriorityGroup) throws JsonProcessingException;

    List<StrategyParameterConfig> getParamConfigData(String crossId);
}
