package net.wanji.opt.task;

import lombok.extern.slf4j.Slf4j;
import net.wanji.opt.servicev2.judgeanalysis.AnalysisGreenCongestionPeriodService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Configurable;
import org.springframework.context.annotation.Profile;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.text.ParseException;

@Component
@Configurable
@EnableScheduling
@Slf4j
@Profile("docker")
public class AnalysisGreenCongestionPeriodWeekTask {
    @Autowired
    private AnalysisGreenCongestionPeriodService analysisGreenCongestionPeriodService;

    @Scheduled(cron = "0 0 2 ? * 1")
    public  void task() throws ParseException {
        analysisGreenCongestionPeriodService.selectCountByCongestionPeriod();
    }
}
