package net.wanji.opt.task;

import lombok.extern.slf4j.Slf4j;
import net.wanji.opt.servicev2.judgeanalysis.AnalysisProblemAndStrategyDayService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Configurable;
import org.springframework.context.annotation.Profile;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.List;

@Component
@Configurable
@EnableScheduling
@Slf4j
@Profile("!dev")
public class AnalysisProblemAndStrategyDayTask {
    @Autowired
    private AnalysisProblemAndStrategyDayService analysisProblemAndStrategyDayService;

    @Scheduled(cron = "0 15 1 * * ?")
    public void task() {
        try {
            analysisProblemAndStrategyDayService.selectCountByType();
        } catch (Exception e) {
            log.error("获取事件优化记录异常", e);
        }
    }
}
