package net.wanji.opt.task;

import lombok.extern.slf4j.Slf4j;
import net.wanji.opt.dao.mapper.report.GreenWaveWeekDataMapper;
import net.wanji.opt.servicev2.report.GreenWaveWeekDataService;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.time.LocalDateTime;

@Component
@Slf4j
public class GreenWaveWeekDataTask implements ApplicationRunner {
    @Resource
    private GreenWaveWeekDataService greenWaveWeekDataService;
    @Override
    public void run(ApplicationArguments args) throws Exception {
        log.info("服务启动时--周总体拥堵概况更新--任务执行时间：" + LocalDateTime.now());
        // 周总体拥堵概况更新
        try {
//            greenWaveWeekDataService.insertGreenWaveWeekData();
        }catch (Exception e){
            log.error("服务启动时--周总体拥堵概况更新--任务执行错误" + e);
        }
        log.info("服务启动时--周总体拥堵概况更新--任务执行结束时间：" + LocalDateTime.now());
    }

    /**
     * 每周一凌晨 0:30 执行的任务
     */
    @Scheduled(cron = "0 30 0 ? * MON")
    public void executeWeeklyTask() {
        //周总体拥堵概况更新
        log.info("定时任务--周总体拥堵概况更新--执行开始时间：" + LocalDateTime.now());
        try {
            greenWaveWeekDataService.insertGreenWaveWeekData();
        }catch (Exception e){
            log.error("定时任务--周总体拥堵概况更新--任务执行错误" + e);
        }
        log.info("定时任务--周总体拥堵概况更新--执行结束时间：" + LocalDateTime.now());
    }

}
